package com.flyfish.framework.backup.controller;

import com.flyfish.framework.backup.domain.Backup;
import com.flyfish.framework.backup.scheduler.BackupScheduler;
import com.flyfish.framework.bean.Result;
import com.flyfish.framework.controller.reactive.ReactiveBaseController;
import com.flyfish.framework.domain.base.NameLikeQo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import jakarta.annotation.Resource;

/**
 * 备份controller
 *
 * @author wangyu
 */
@RestController
@RequestMapping("backups")
public class BackupController extends ReactiveBaseController<Backup, NameLikeQo<Backup>> {

    @Resource
    private BackupScheduler backupScheduler;

    /**
     * 立即创建备份
     *
     * @return 结果
     */
    @PostMapping("task")
    public Result<String> createTask() {
        backupScheduler.backup();
        return Result.accept("已创建备份，完成后会出现在列表中，请稍后刷新再试。");
    }
}
