package com.flyfish.framework.validation.validators;

import com.flyfish.framework.context.SpringContext;
import com.flyfish.framework.validation.annotations.ContainsBean;
import org.apache.commons.lang3.StringUtils;

import jakarta.validation.ConstraintValidator;
import jakarta.validation.ConstraintValidatorContext;

/**
 * 包含在ioc容器的bean
 *
 * @author wangyu
 */
public class ContainsBeanValidator implements ConstraintValidator<ContainsBean, String> {

    @Override
    public boolean isValid(String value, ConstraintValidatorContext constraintValidatorContext) {
        if (StringUtils.isBlank(value)) return true;
        try {
            SpringContext.getBean(value);
            return true;
        } catch (Exception ignored) {
            return false;
        }
    }
}
