package com.flyfish.framework.annotations;

import com.flyfish.framework.generation.CodeRuleStrategy;

import java.lang.annotation.*;

/**
 * 代码生成规则指定
 * 用于code值得初始化，区分场景
 */
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface CodeRule {

    /**
     * 策略实现类
     *
     * @return 结果
     */
    Class<? extends CodeRuleStrategy> value() default CodeRuleStrategy.class;
}
