package com.flyfish.framework.annotations;

import java.lang.annotation.*;

/**
 * 表单项属性
 *
 * @author wangyu
 */
@Target({ElementType.FIELD, ElementType.ANNOTATION_TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface FormItem {

    /**
     * @return 组件
     */
    String component() default "";

    /**
     * 属性key=value
     *
     * @return 结果
     */
    Prop[] props() default {};

    /**
     * @return 布局
     */
    String layout() default "";

    /**
     * 提示信息
     *
     * @return 结果
     */
    String help() default "";

    /**
     * 表单域属性
     *
     * @author wangyu
     */
    @Target(ElementType.FIELD)
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @interface Prop {

        /**
         * 键
         *
         * @return 键
         */
        String key();

        /**
         * 值
         *
         * @return 值
         */
        String value();
    }
}
