package com.flyfish.framework.domain.tree;

import com.flyfish.framework.domain.base.AuditDomain;
import lombok.Getter;
import lombok.Setter;
import org.springframework.data.annotation.Transient;
import org.springframework.data.relational.core.mapping.Column;

import java.util.List;

@Getter
@Setter
public abstract class TreeDomain<T extends TreeDomain<T>> extends AuditDomain {

    public static final String ROOT = "0";

    // 父id，顶级是0
    @Column("parent_id")
    private String parentId;

    // 冗余的父ids，方便查询
    @Column("parent_ids")
    private List<String> parentIds;

    // 深度，遍历标识
    private Integer depth;

    // 冗余的字段，用来放儿子
    @Transient
    private List<T> children;
}
