package com.flyfish.framework.mongodb.config.callback;

import com.flyfish.framework.auditor.callback.AuditorCallback;
import com.flyfish.framework.domain.base.Domain;
import org.reactivestreams.Publisher;
import org.springframework.data.mongodb.core.mapping.event.BeforeConvertCallback;
import org.springframework.lang.NonNull;

public class MongoAuditorMongoCallback extends AuditorCallback implements BeforeConvertCallback<Domain> {

    /**
     * 实体回调方法，用于在域对象转换为持久化对象之前调用。该方法可以返回相同的域对象，也可以返回经过修改的域对象，并使用 {@link Publisher} 发布要持久化的对象。
     *
     * @param entity     要保存的领域对象。
     * @param collection 集合名称 (可能指数据库中的集合概念)。
     * @return 发布要持久化的领域对象。
     */
    @Override
    @NonNull
    public Domain onBeforeConvert(@NonNull Domain entity, @NonNull String collection) {
        // 执行auditor
        return audit(entity);
    }
}
