package com.flyfish.framework.r2dbc.config.annotations;

import com.flyfish.framework.r2dbc.repository.factory.DefaultReactiveRepositoryFactoryBean;
import com.flyfish.framework.r2dbc.repository.impl.QueryingR2dbcReactiveRepository;
import org.springframework.core.annotation.AliasFor;
import org.springframework.data.r2dbc.repository.config.EnableR2dbcRepositories;

import java.lang.annotation.*;

/**
 * 启用注解，能够指定基本路径
 *
 * @author wangyu
 */
@EnableR2dbcRepositories(
        repositoryFactoryBeanClass = DefaultReactiveRepositoryFactoryBean.class,
        repositoryBaseClass = QueryingR2dbcReactiveRepository.class
)
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Inherited
public @interface EnableR2dbcRepo {

    /**
     * 扫描的基本路径
     *
     * @return 结果
     */
    @AliasFor(annotation = EnableR2dbcRepositories.class)
    String[] basePackages() default {};
}
