package com.flyfish.framework.r2dbc.config.dialect;

import com.flyfish.framework.r2dbc.config.convert.AdditionalConverters;
import lombok.Getter;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.data.r2dbc.dialect.MySqlDialect;
import org.springframework.data.relational.core.dialect.ArrayColumns;
import org.springframework.data.relational.core.dialect.ObjectArrayColumns;
import org.springframework.lang.NonNull;

import java.util.Collection;

/**
 * 更高级的mysql别名，支持json array、json object映射
 */
@Getter
public class AdvanceMysqlDialect extends MySqlDialect {

    private final Collection<Object> converters;

    private static final Collection<Object> additionalConverters = AdditionalConverters.ADDING_CONVERTERS;

    public static final MySqlDialect INSTANCE = new AdvanceMysqlDialect();

    public AdvanceMysqlDialect() {
        this.converters = CollectionUtils.union(super.getConverters(), additionalConverters);
    }

    @Override
    @NonNull
    public ArrayColumns getArraySupport() {
        return ObjectArrayColumns.INSTANCE;
    }
}
