CREATE TABLE IF NOT EXISTS `t_log`
(
    `id`         VARCHAR(36)  NOT NULL COMMENT '主键',
    `code`       VARCHAR(32)  NOT NULL COMMENT '编码',
    `name`       VARCHAR(100) NOT NULL COMMENT '名称',
    `type`       VARCHAR(24)  NOT NULL COMMENT '日志类型',
    `business`   VARCHAR(36)  NULL COMMENT '业务类型',
    `module`     VARCHAR(36)  NULL COMMENT '模块类型',
    `signature`  VARCHAR(250) NULL COMMENT '方法签名',
    `uri`        VARCHAR(300) NOT NULL COMMENT '请求地址',
    `body`       TEXT         NULL COMMENT '请求参数',
    `response`   TEXT         NULL COMMENT '响应结果',
    `error`      TEXT         NULL COMMENT '错误日志',
    `period`     BIGINT       NULL COMMENT '操作耗时',
    `start_time` DATETIME     NULL COMMENT '操作时间',
    `end_time`   DATETIME     NULL COMMENT '完成时间',
    `operator`   VARCHAR(36)  NULL COMMENT '操作人',
    `ip`         VARCHAR(50)  NULL COMMENT '访问ip',
    `success`    BIT(1)       NOT NULL DEFAULT b'0' COMMENT '成功状态',
    `delete`     BIT(1)       NOT NULL DEFAULT b'0',
    PRIMARY KEY (`id`)
) COMMENT '日志表';
