package com.flyfish.framework.user.domain;

import com.flyfish.framework.domain.base.NameLikeQo;
import com.flyfish.framework.domain.po.Role;
import com.flyfish.framework.query.QueryDefinition;
import lombok.Getter;
import lombok.Setter;

import java.util.List;

/**
 * 角色查询实体
 *
 * @author wybab
 */
@Getter
@Setter
public class RoleQo extends NameLikeQo<Role> {

    /**
     * 是否仅管理员可选
     */
    private Boolean admin;

    /**
     * 是否系统内置
     */
    private Boolean system;

    /**
     * 额外的查询拼接，仅用于getList，用于查询回显
     */
    private List<String> additions;

    @Override
    public QueryDefinition queryBuilder() {
        return super.queryBuilder()
                .mutate()
                .and(Role::getAdmin).eq(admin)
                .and(Role::getSystem).eq(system);
    }

    /**
     * 因存在不稳定因素，永不为空
     *
     * @return 结果
     */
    @Override
    public boolean isEmpty() {
        return false;
    }
}
