package com.flyfish.framework.configuration.redis;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.PropertyAccessor;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.redis.serializer.Jackson2JsonRedisSerializer;

public class JacksonRedisSerializerFactory {

    public static Jackson2JsonRedisSerializer<Object> produce() {
        // 构造object mapper
        ObjectMapper om = new ObjectMapper();
        om.setVisibility(PropertyAccessor.ALL, JsonAutoDetect.Visibility.ANY);
        om.enableDefaultTyping(ObjectMapper.DefaultTyping.NON_FINAL);
        // 设置序列化
        return new Jackson2JsonRedisSerializer<Object>(om, Object.class);
    }
}
